<?php 
/*
Plugin Name: WP-Banglatools
Plugin URI: http://blog.manchumahara.com
Description: One of the dream project by manchumahara to cover all bangla related solution for wordpress. Keep tuning !
Author: Sabuj Kundu aka manchumahara
Version: 1.0
Author URI: http://blog.manchumahara.com
*/
/*  
	Copyright 2010  Sabuj Kumar Kundu (email : manchumahara@gmail.com)
	
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
?>
<?php 
/*
 * Use WordPress 2.6 Constants
 */ 
if (!defined('WP_CONTENT_DIR')) {
	define( 'WP_CONTENT_DIR', ABSPATH.'wp-content');
}
if (!defined('WP_CONTENT_URL')) {
	define('WP_CONTENT_URL', get_option('siteurl').'/wp-content');
}
if (!defined('WP_PLUGIN_DIR')) {
	define('WP_PLUGIN_DIR', WP_CONTENT_DIR.'/plugins');
}
if (!defined('WP_PLUGIN_URL')) {
	define('WP_PLUGIN_URL', WP_CONTENT_URL.'/plugins');
}
$wpbntool_path = WP_CONTENT_URL.'/plugins/'.plugin_basename(dirname(__FILE__)).'/'; // keep in mind about the trailing slash :D
/*
 * Plugin icon provided by excellent web designer Robiul Alam(robiulalam6@gmail.com)
 */ 
$wpbntoolicon_url = $wpbntool_path."images/banglatools.gif";

add_action('admin_menu', 'wpbanglatools_menu');

//add_action('init', 'banglatoolskbjs_init');

//add_action('wp_footer','banglatoolskbjs_init');
function banglatoolskbjs_init(){	
	if (current_user_can('edit_posts') || current_user_can('edit_pages')) {
		//wp_register_script('jquery');
		//var_dump(yes);
		wp_enqueue_script('jquery');
		//wp_enqueue_script('wpbanglatoolskbjs',$wpbntool_path.'js/wpbanglatools.js', array('jquery'),'2',true);
		wp_enqueue_script('wpbanglatools',$wpbntool_path.'js/wpbanglatools.js','','2',true);
	}

}
/*
 * Function for plugin options page
 */
function wpbanglatools_menu(){
	global $wpbntoolicon_url;
	if (function_exists('add_menu_page')) {
		//$page_title, $menu_title, $access_level, $file, $function = '', $icon_url = ''
		add_menu_page('Banglatools Setting','Bangla Tools', 8, 'wp-banglatools/setting.php','',$wpbntoolicon_url);
	}
	if (function_exists('add_submenu_page')) {
		//$parent, $page_title, $menu_title, $access_level, $file, $function = ''
		add_submenu_page('wp-banglatools/setting.php','Banglatools Setting','Settings', 8, 'wp-banglatools/setting.php');
	
	}
}
global $wpbanglatools_ver; 
$wpbanglatools_ver = "1.0";
#Plugin activation hook for  initial setup and checking
register_activation_hook(__FILE__,'wpbanglatools_init_setup');

/*
 * Function for initial setup, change plugin version and update options for plugin
 */ 
function wpbanglatools_init_setup(){
	global $wpbanglatools_ver;
	$current_installed_ver = get_option('wpbanglatools_ver');
	if($current_installed_ver == '')
	{		
		//first time install :D
		add_option('wpbanglatools_ver',$wpbanglatools_ver);	
		add_option('banglatools_digit_fnt',1);
	}
	else if($current_installed_ver != $wpbanglatools_ver)
	{
		// new version ... so update version number :P
		update_option('wpbanglatools_ver',$wpbanglatools_ver);	
		//introduce in ver 0.2
		//add_option('banglatools_digit_fnt',1);		
	}
}

function add_wpbanglatools_settings_link( $links ) { 
  $settings_link = '<a href="admin.php?page=wp-banglatools/setting.php">Settings</a>'; 
  array_unshift( $links, $settings_link ); 
  return $links; 
}
$plugin = plugin_basename(__FILE__); 
add_filter("plugin_action_links_$plugin", 'add_wpbanglatools_settings_link' );	

$banglatools_digit_fnt = intval(get_option('banglatools_digit_fnt'));
if(function_exists('number_format_i18n')){
	if($banglatools_digit_fnt && is_admin()){return;}
	
	add_filter('number_format_i18n', 'wpbanglatools_i18n_digit', 10, 1);
	add_filter('date_i18n', 'wpbanglatools_i18n_date',10,2);
}
/*
 object(WP_Locale)#635 (9) { 
  ["weekday"]=>  array(7) { [0]=>  string(6) "Sunday" [1]=>  string(6) "Monday" [2]=>  string(7) "Tuesday" [3]=>  string(9) "Wednesday" [4]=>  string(8) "Thursday" [5]=>  string(6) "Friday" [6]=>  string(8) "Saturday" } 
  ["weekday_initial"]=>  array(7) { ["Sunday"]=>  string(1) "S" ["Monday"]=>  string(1) "M" ["Tuesday"]=>  string(1) "T" ["Wednesday"]=>  string(1) "W" ["Thursday"]=>  string(1) "T" ["Friday"]=>  string(1) "F" ["Saturday"]=>  string(1) "S" } 
  ["weekday_abbrev"]=>  array(7) { ["Sunday"]=>  string(3) "Sun" ["Monday"]=>  string(3) "Mon" ["Tuesday"]=>  string(3) "Tue" ["Wednesday"]=>  string(3) "Wed" ["Thursday"]=>  string(3) "Thu" ["Friday"]=>  string(3) "Fri" ["Saturday"]=>  string(3) "Sat" } 
  ["month"]=>  array(12) { ["01"]=>  string(7) "January" ["02"]=>  string(8) "February" ["03"]=>  string(5) "March" ["04"]=>  string(5) "April" ["05"]=>  string(3) "May" ["06"]=>  string(4) "June" ["07"]=>  string(4) "July" ["08"]=>  string(6) "August" ["09"]=>  string(9) "September" [10]=>  string(7) "October" [11]=>  string(8) "November" [12]=>  string(8) "December" } 
  ["month_abbrev"]=>  array(12) { ["January"]=>  string(3) "Jan" ["February"]=>  string(3) "Feb" ["March"]=>  string(3) "Mar" ["April"]=>  string(3) "Apr" ["May"]=>  string(3) "May" ["June"]=>  string(3) "Jun" ["July"]=>  string(3) "Jul" ["August"]=>  string(3) "Aug" ["September"]=>  string(3) "Sep" ["October"]=>  string(3) "Oct" ["November"]=>  string(3) "Nov" ["December"]=>  string(3) "Dec" } 
  ["meridiem"]=>  array(4) { ["am"]=>  string(2) "am" ["pm"]=>  string(2) "pm" ["AM"]=>  string(2) "AM" ["PM"]=>  string(2) "PM" } 
  ["text_direction"]=>  string(3) "ltr" ["locale_vars"]=>  array(1) { [0]=>  string(14) "text_direction" } 
  ["number_format"]=>  array(3) { ["decimals"]=>  int(0) ["decimal_point"]=>  string(1) "." ["thousands_sep"]=>  string(1) "," } }

 */
function wpbanglatools_i18n_digit($en_number){
	$en_digits = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9');
	$bn_digits = array('০', '১', '২', '৩', '৪', '৫', '৬', '৭', '৮', '৯');
	$en_number = str_replace($en_digits, $bn_digits, $en_number);
	//var_dump($en_number);	
	return $en_number;
}

function wpbanglatools_i18n_date($en_date, $format){
	//var_dump($format);
	//check format in wp codex http://codex.wordpress.org/Formatting_Date_and_Time
	//month
	$en_months = array('January','February','March','April','May','June','July','August','September','October','November','December');	
  	$bn_months = array('জানুয়ারী','ফেব্রুয়ারী','মার্চ','এপ্রিল','মে','জুন','জুলাই','আগস্ট','সেপ্টেম্বর','অক্টোবর','নভেম্ভর','ডিসেম্বর');
  	
  	$en_months_short = array('January','February','March','April','May','June','July','August','September','October','November','December');
  	$bn_months_short = array('জানুয়ারী','ফেব্রুয়ারী','মার্চ','এপ্রিল','মে','জুন','জুলাই','আগস্ট','সেপ্টেম্বর','অক্টোবর','নভেম্ভর','ডিসেম্বর');
	
	//week	
	$en_weeks=  array('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday'); 
	$en_weeks_short=  array('Sun','Mon','Tue','Wed','Thu','Fri','Sat'); 
	$en_weeks_short_initial=  array('S','M','T','W','T','F','S'); 
	
	$bn_weeks = array ('রবিবার','সোমবার','মঙ্গলবার','বুধবার','বৃহঃবার','শুক্রবার','শনিবার');
	$bn_weeks_short = array ('রবি','সোম','মঙ্গল','বুধ','বৃহঃ','শুক্র','শনি');
	$bn_weeks_short_initial=  array('র','সো','ম','বু','বৃ','শু','শ'); 
  	
  	//meriian ... 
  	$en_meridian = array('am','pm');
  	$bn_meridian = array('পুর্বাহ্ন','অপরাহ্ণ');  
  	
  	//ordinal
  	$en_ordinal = array('st','nd','rd','th');
  	$bn_ordinal = array('','','','','');
  	//let's apply regex depending on format
  	//parse english month with data format
    //details about dataformat used in wordpress is here http://codex.wordpress.org/Formatting_Date_and_Time  
  	if(strpos($format,'F') !== FALSE)
  	{
  		//F 	Textual full 	January – December
  		$en_date = str_replace($en_months, $bn_months, $en_date);
  	}
  	if(strpos($format,'M'))
  	{
  		//M 	Textual three letters 	Jan - Dec
  		$en_date = str_replace($en_months_short, $bn_months_short, $en_date);
  	}
  	
  	//now parse weekday depending on data format
  	if(strpos($format,'l'))
  	{
  		//l 	Full name  (lowercase 'L') 	Sunday – Saturday
  		$en_date = str_replace($en_weeks, $bn_weeks, $en_date);
  	}
  	if(strpos($format,'D'))
  	{
  		//D 	Three letter name 	Mon – Sun
  		$en_date = str_replace($en_weeks_short, $bn_weeks_short, $en_date);
  		
  	}
  	if(strpos($format,'a') || strpos($format,'A'))
  	{
  		//a 	Lowercase 	am, pm
		//A 	Uppercase 	AM, PM
  		$en_date = str_ireplace($en_meridian, $bn_meridian, $en_date); // why not run a case insensitive regex :P
  		
  	}
  	if(strpos($format,'j') && strpos($format,'S'))
  	{
  		$en_date = str_ireplace($en_ordinal, $bn_ordinal, $en_date);
  	}
  	//at last make the digits bangla :D
  	//though we need to make digit banglafy for date if $format contains d,j,m,n,Y,y,
	return wpbanglatools_i18n_digit($en_date); 	
}


?>
